
<div class="row">
 <div class="col-12 d-flex justify-content-between" >
   <a href="/teaching/xml/dtd"class="btn btn-primary" role="button" >DTD </a> <a href="/teaching/"class="btn btn-primary" role="button" >Sommaire </a>  <a href="/teaching/xml/xpath"class="btn btn-primary" role="button" >XPath</a>
 </div>
</div>
<h1><%= title %> </h1>
<hr/>


<h2>Introduction </h2>
<hr/>
<p>
 Un xml schema décris la structure d'un document XML.

 L'intérêt du XML schema est de définir la manière de construire un document XML:
 <ul>
  <li>Les élements et attribus qui peuvent y être déclarer</li>
  <li>Le nombre est l'ordre d'apparition des élements</li>
  <li>Le type des éléments est attributs</li>
  <li>Les valeurs par défaut ou fixe</li>
 </ul>
</p>


<h2>Typage de donnée</h2>
<hr/>
Le plus grand avantage du XML schemas est de pouvoir supporter le typage des données.
<ul>
 <li>Décrire le contenue.</li>
 <li>Valider l'exactitude des données.</li>
 <li>Restreindre les données.</li>
 <li>définir des formats pour les données.</li>
 <li>Conversion de donnée en différents type.</li>
</ul>

<h3>Exemple</h3>
<p>Imaginons que nous souhaitons envoyer une date.
Il est tout à fait légal d'écrire une date comme "01-11-2019", mais dans certains pays le 01 sera interpréter comme le 1er Novembre et dans d'autres comme le 11 Janvier.
</p>
<p>XML Schemas permet de définir la date dans un type "Date<i>(YYYY-MM-DD)"</i> pouvant être compris par tous.</p>
<pre><code>&lt;data type="date"&gt;2019-01-11&lt;data&gt;</code></pre>

<h2>Déclaration</h2>
<hr/>

<h3>Schema</h3>

<p>La définition d'un schéma se fait dans un fichier <b>.xsd</b>:</p>
<pre><code>
 &lt;?xml version="1.0"?&gt;
  &lt;xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"&gt;
   .
   .
   .
 &lt;/xs:schema&gt;
</code></pre>
<pre><code>xmlns:xs="http://www.w3.org/2001/XMLSchema"</code></pre> 
<p>Indique que les éléments et les données utilisées par le schéma viennent du namespace "http://www.w3.org/2001/XMLSchema". Il spécifie aussi que tous les types et données commence par le préfixe <b>xs:</b></p>

<h3>Document XML</h3>
<hr/>

<p>Le schéma est lié à l'élément racine du document XML. </p>
<pre><code>
&lt;?xml version="1.0" encoding="UTF-8"?&gt;

&lt;root 
      xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
      xsi:noNamespaceSchemaLocation="note.xsd"&gt;
  ...
&lt;/root&gt;

</code></pre>
<h3>Simple Element</h3>
<p>Lorsqu'un élément xml ne contient que de la donnée (pas d'élément enfant ou d'attributs), on dit que c'est un élement simple</p>

<pre><code>
&lt;xs:element name="message" type=xs:string"/&gt;
</code></pre>

<p>Ici, nous déclarons un élément message de type <i>String</i>
il existe d'autres types : <i>integer, date, boolean, ...</i></p>

<pre><code>
&lt;xs:element name="message" type=xs:string" default="red"/&gt;
</code></pre>
<p>La valeur par défaut est <i>red</i> si la valeur n'est pas renseignée.</p>

<pre><code>
&lt;xs:element name="message" type=xs:string" fixed="red"/&gt;
</code></pre>

>La valeur est automatiquement fixée à <i>red</i>, elle ne peut pas être modifiée.

<h3>Restrictions</h3>
<p>Il est possible de définir des restrictions sur des éléments:</p>
<pre><code>
&lt;xs:element name="age"&gt;
  &lt;xs:simpleType&gt;
    &lt;xs:restriction base="xs:integer"&gt;
      &lt;xs:minInclusive value="0"&gt;
      &lt;xs:maxInclusive value="120"&gt;
    &lt;/xs:restriction&gt;
  &lt;/xs:simpleType&gt;
&lt;/xs:element&gt;
</code></pre>

<p>L'exemple définie un élément <b>age</b>, de type simple mais dont la valeur est un entier compris en 0 inclut, et 120 inclut.</p>

 <div class="alert alert-info" role="alert">
 La déclaration de l'élément simple n'est plus la même.</div>


<pre><code>
&lt;xs:element name="Marque voiture"&gt;
  &lt;xs:simpleType&gt;
    &lt;xs:restriction base="xs:string"&gt;
      &lt;xs:enumeration value="Peugeot"/&gt;
      &lt;xs:enumeration value="Renault"/&gt;
      &lt;xs:enumeration value="BMW"/&gt;
    &lt;/xs:restriction&gt;
  &lt;/xs:simpleType&gt;
&lt;/xs:element&gt;
</code></pre>
<p>La restriction ce fait sur un nombre de valeurs possible pour l'élément</p>
 <div class="alert alert-info" role="alert">
 Attention à la casse !</div>

<pre><code>
&lt;xs:element name="numero_telephone"&gt;
  &lt;xs:simpleType&gt;
    &lt;xs:restriction base="xs:integer"&gt;
      &lt;xs:pattern value="[0-9]{10}"/&gt;
    &lt;/xs:restriction&gt;
  &lt;/xs:simpleType&gt;
&lt;/xs:element&gt;
</code></pre>
<p>La restriction ce fait sur un motif.</p>
Il existe d'autres paramètres disponibles dans la <a href="https://www.w3schools.com/xml/schema_facets.asp" >documentation</a>
<h3>Complex Element</h3>
<p>Un élément qui possède un attribut et/ou des éléments enfants et/ou vide, est un type complexe. Exemple:</p>

<pre><code>
&lt;produit pid="42"/&gt;
   
&lt;employe&gt;
  &lt;prenom &gt;Donald &lt;prenom/&gt;
  &lt;nom&gt;Duck &lt;nom/&gt;
&lt;/employe&gt;

&lt;note message="foo"/&gt;

</code></pre>
<p>Il existe 2 façons de déclarer un type complexe:</p>
<ul>
  <li>A l'intérieur de l'élément:
     <pre><code>
&lt;xs:element name="employe"&gt;
  &lt;xs:complexType&gt;
     &lt;xs:sequence&gt;
        &lt;xs:element name="prenom" type="xs:string"/&gt;
        &lt;xs:element name="nom" type="xs:string"/&gt;
     &lt;/xs:sequence&gt;
   &lt;/xs:complexType&gt;
&lt;/xs:element&gt;
</code></pre>
 </li>
<li>A l'extérieur:
     <pre><code>
&lt;xs:element name="employe" type="info" &gt;
&lt;xs:element name="etudiant" type="info" &gt;
&lt;xs:element name="membre" type="info" &gt;


&lt;xs:complexType name="info"&gt;
  &lt;xs:sequence&gt;
   &lt;xs:element name="prenom" type="xs:string"/&gt;
   &lt;xs:element name="nom" type="xs:string"/&gt;
  &lt;/xs:sequence&gt;
&lt;/xs:complexType&gt;
</code></pre>
</li>


<h3>Element vide</h3>
<hr/>
<pre><code>&lt;vue/&gt;</code></pre>
<pre><code>&lt;xs:element name="vue" type="t_vue"/&gt;</code></pre>
<pre><code>
&lt;xs:complexType name="t_vue"/&gt;
  &lt;xs:sequence /&gt;
&lt;/xs:complexType&gt;
</code></pre>

<h3>Attributs</h3>
<p>Le schéma d'un attibut est :</p>
<pre><code>&lt;xs:attribut name="x", type="y" /&gt; </code></pre>
<p>Les éléments simple non pas d'attributs.</p>
<p>/Exemple:</p>

  <pre><code>
&lt;xs:element name="employe"&gt;
  &lt;xs:complexType&gt;
    &lt;xs:sequence&gt;
      &lt;xs:attribut name="numeroSecu" type="xs:integer"/&gt;
      &lt;xs:element name="prenom" type="xs:string"/&gt;
      &lt;xs:element name="nom" type="xs:string"/&gt;
    &lt;/xs:sequence&gt;
  &lt;/xs:complexType&gt;
&lt;/xs:element&gt;
</code></pre>

<p>Equivaut à :</p>

<pre><code>
&lt;employe numeroSecu="12131235"&gt;
  &lt;prenom&gt;Donald&lt;/prenom&gt;
  &lt;nom&gt;Duck&lt;/nom&gt;
&lt;/employe&gt;
</code></pre>

<div class="alert alert-info"><p>la définition des attributs se fait toujours après la balise <i>xs:sequence</i></p></div>
<h3>Valeur par défaut et Fixe</h3>
<hr>
<p>Les attributs peuvent avoir une valeur par défaut ou fixe</p>
<pre><code>&lt;xs:attribute name="lang" type="xs:string" default="EN"/&gt;</code></pre>

<pre><code>&lt;xs:attribute name="lang" type="xs:string" fixed="EN"/&gt;</code></pre>
<h3>Valeur Optionnelle et obligatoire</h3>
<hr>
<p>Par défaut un attribut est optionnel, pour la rendre obligatoire il faut la spécifier:</p>
<pre><code>&lt;xs:attribute name="lang" type="xs:string" use="required"/&gt;</code></pre>

<h3>Eléments avec texte et attributs</h3>
<hr/>
<pre><code>&lt;message langue="fr"&gt;Hello world !&lt;/message&gt; </code></pre>
<pre><code> &lt;xs:element name="message" type="t_message"/&gt;</code></pre>
<pre><code>
&lt;xs:complexType name="t_message"&gt;
  &lt;xs:simpleContent&gt;
    &lt;xs:extension base="xs:string"&gt; &lt;!-- Type du contenu --&gt;
      &lt;xs:attribute name="langue" type="xs:string"/&gt;
    &lt;/xs:extension&gt;
  &lt;/xs:simpleContent&gt;
&lt;/xs:complexType&gt;
</code></pre>

<h3>Indicateurs</h3>
<hr/>
<b>Ordre</b>
pour les types complexes:
<ul>
  <li><b>xs:sequence</b> : les éléments apparaissent selon un ordre précis. </li>
  <li><b>xs:all</b> : les éléments apparaissent dans n'importe quel ordre. </li>
  <li><b>xs:choice</b> : Un éléments parmis la liste. </li>
</ul>
<b>Occurence</b>
pour définir le nombre d'occurences d'un élément:
<ul>
  <li><b>minOccurs</b> : Occurences minimum de l'élément. </li>
  <li><b>max:Occurs</b> : Occurences maximum de l'élément.. </li>
</ul>

<p>Par exemple:</p>

<pre><code>&lt;xs:element name="prenom" type="xs:string" maxOccurs="3"/&gt;
</code></pre>

Pour des occurences illimitées : maxOccurs="unbounded".

<h3>Exemple complet</h3>
<hr/>

Document XML
<pre><code>&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;note xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
      xsi:noNamespaceSchemaLocation="note.xsd"&gt;
  &lt;auteur&gt;Alice&lt;/auteur&gt;
  &lt;destinataire&gt;Bob&lt;/destinataire&gt;
  &lt;message&gt;Pense à sortir le chat...&lt;/message&gt;
&lt;/note&gt;
</code></pre>

Schéma XSD
<pre><code>
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"&gt;

  &lt;xs:element name="note" type="t_note"/&gt;

  &lt;xs:complexType name="t_note"&gt;
    &lt;xs:sequence&gt;
      &lt;xs:element name="auteur" type="xs:string"/&gt;
      &lt;xs:element name="destinataire" type="xs:string"/&gt;
      &lt;xs:element name="message" type="t_message"/&gt;
    &lt;/xs:sequence&gt;
    &lt;xs:attribute name="date" type="xs:date"/&gt;
  &lt;/xs:complexType&gt;

  &lt;xs:complexType name="t_message"&gt;
    &lt;xs:simpleContent&gt;
      &lt;xs:extension base="r_message"&gt;
        &lt;xs:attribute name="langue" type="xs:string"/&gt;
      &lt;/xs:extension&gt;
    &lt;/xs:simpleContent&gt;
  &lt;/xs:complexType&gt;

  &lt;xs:simpleType name="r_message"&gt;
    &lt;xs:restriction base="xs:string"&gt;
      &lt;xs:maxLength value="150"/&gt;
    &lt;/xs:restriction&gt;
  &lt;/xs:simpleType&gt;

&lt;/xs:schema&gt;

</code></pre>
<h3>Documentation</h3>
<hr/>
<a href="https://www.w3schools.com/xml/schema_howto.asp" ><h3>lien<br/><br/></h3></a>
<div class="row">
 <div class="col-12 d-flex justify-content-between" >
   <a href="/teaching/xml/dtd"class="btn btn-primary" role="button" >DTD </a> <a href="/teaching/"class="btn btn-primary" role="button" >Sommaire </a>  <a href="/teaching/xml/xpath"class="btn btn-primary" role="button" >XPath</a>
 </div>
</div>
